//+------------------------------------------------------------------+
//|                                          TMS Angleator v3.00.mq4 |
//|                                                     Griffin Soul |
//|                         http://www.forexfactory.com/griffinssoul |
//+------------------------------------------------------------------+
//
// MODIFICATIONS
//
// 2015.07.05  MRaye  Added option to use WAvg of both TDI lines for angle calculations.
// 2015.07.05  MRaye  Added Wayover Bought/Sold states to better visualize extremes.
// 2015.07.05  MRaye  Changed panel ratio text to be DimGray.
// 2015.07.08  MRaye  Added [Panel Location] parm to allow for different panel placements.
// 2015.07.08  MRaye  Added [xAxis Offset] & [Instance ID] parms to allow for multiple 
//                    panels on the same chart.
// 2015.07.09  MRaye  Combined Arrow & Zone into single fn to elimate iCustom recalculations.
// 2015.07.09  MRaye  Combined Angles & Seperation into single fn to elimate iCustom recalculations.
// 2015.07.09  MRaye  Added/modified Seperation text to include confirmed crossing states.
// 2015.07.10  MRaye  Added [..RSIPrice] & [..TradeSig] parms to accomodate for different parameter
//                    orders in external TDI indicators.
// 2015.07.14  MRaye  Renamed object identifiers to eliminate confusion when dealing with multiple TFs.
// 2015.07.14  MRaye  Added ability to turn on/off M5 statistics for scalp trading.
// 2015.07.15  MRaye  Added MTF seperation indicator to panel.
// 2015.07.16  MRaye  Added M5 divider line on panel to better visually seperate M5 from other TFs.

/* 2016.02.16 v2vboni

    Added Weekly TF (If M5 TF is set to false)
    Option to load a different currency pair
    Option to show currency symbol and TF on the top header
    Values and Text color changes according to current trend/behavior
    Option to move the Panel Up/Down and Left/Right
    Panel Ratio display control | It shows up only on sub-window
    Shows the current MTF RSI Price Level Value
    Created TMS-TDI-RT-Replica
      - TDI-RT-Clone (Real Time) indicator copy with TDI calculation from TDI_mtf b600
    Created TDI_RSI_10
      - TDI with RSI PERIDO of 10  and is PRICE_CLOSED
    February Added Dropdown menu for pre-selected set of TFs
    Added Dropdown menu for TDI Indicator Input, and the  Angular Type selection
    Added Dropdown menu for Window location
    Added Vertical Line TF Divider which acts like an anchor | You can remove this vertical line as an option   
*/

#property copyright "Griffin Soul"
#property link      "http://www.forexfactory.com/showthread.php?p=8736115#post8736115"
#property version   "3.01"
#property strict
#property indicator_chart_window

// External settings
//extern int    Panel_Location = 1;          // Panel Location (0=TopLeft, 1=TopRight, 2=BottomLeft, 3=BottomRight)

extern string loadDefaultSymbol="current";   // Default Currency Pair - e.g. EURUSD
extern bool   showSymbol=true;               // Show Instrument Symbol?  -top header info
extern bool   showCurrentTF=true;            // Show Current TF?
extern string  comment1="<<< Put Me In Where? >>>"; 
enum putMeIn  
  {
   where0   = 0,     // Main Chart Window
   where1   = 1,     // Sub Window 1
   where2   = 2,     // Sub Window 2
   where3   = 3,     // Sub Window 3
   where4   = 4,     // Sub Window 4          
  };
input putMeIn Window=1;  
extern string  comment2="<<< Choose Your Set of Time Frames >>>";                       
enum ShowTFs  
  {
   tfs1   = 1,     // M1 M5 M15 M30 H1
   tfs2   = 2,     // M5 M15 M30 H1 H4
   tfs3   = 3,     // M15 M30 H1 H4 D1 
   tfs4   = 4,     // M15 M30 H1 H4
   tfs5   = 5,     // M30 H1 H4 D1 W1
   tfs6   = 6,     // H1 H4 D1 W1 MN1
   tfs8   = 7,     // M5 M15 M30 H1 H4 D1  
   tfs9   = 8,     // M15 M30 H1 H4 D1 W1       
  };
input ShowTFs TFs=3;
extern string  comment3="<<< Panel Box Configuration | Content >>>"; 
extern int    shiftDown=0;                  // Shift Panel Up/Down
extern int    iXOffset = 0;                  // Shift Panel Left/Right
extern string Instance = "TMSAngl1";         // Instance ID - use for multiple indicator instances
extern color  Back_Ground_Color = clrBlack;  // Choose Panel Background Color
extern bool   transBackground = true;       //  Make Panel Background Transparent?
extern string Font_Type = "Arial Narrow";    // Font Type: Arial Narrow by design
extern int    Font_Size = 8;                 // Maximum Font Size: 8 by design
extern color  Text_Color = clrSteelBlue;      // Font Color
extern bool   showAngulardiff=false;           // Show Angular difference/shortest way between two angles [0-90]
extern bool   showRSIplBoxType=true;         // RSI Price Line as Box: True = Box | False = Numerical values 
extern int    MTFboxSize=10;                 // Box Size   = 10 default
extern int    MTFarrowSize=10;               // Arrow Size = 10 default
extern bool   showTFdivider=true;            // Show Vertical Line divider | Act as anchor
extern color  verticalLineColor=clrSlateGray; // Vertical Line Color
extern bool   showPanelRatio=true;           // Show Panel Ratio?  - it shows up on sub-window only
extern color  PanelRatioColor=clrSilver;     // Panel Ratio Color


extern string  comment4="<<< Choose Your TDI Input Indicator >>>"; 
enum TDIinput 
  {
   tdi1   = 1,     // Traders_Dynamic_Index
   tdi2   = 2,     // TMS-TDI-RT-Replica    
   tdi3   = 3,     // TDI-Red-Green   
   tdi4   = 4,     // TDI-RT-Clone
   tdi5   = 5,     // TDI_RSI_10     
  };
  
input TDIinput inputTDI=2;

extern string  comment9="<<< Choose Your TDI Angle Type >>>"; 
enum Angular  
  {
   angle1   = 0,     // TDI WAvg
   angle2   = 1,     // Green (Rel.Angle)
   angle3   = 2,     // Red
         
  };
input Angular angleType=1;
extern double TDI_cross_threshold = 1.5;  // TDI cross happens within Black/Red Line Separation less than 1.00 (default)
extern double TDI_normal_threshold = 5.0; // Separation is Normal for values less than 5.00 (default) & Strong > 5.00
extern string comment10="<<< Color My World >>>"; 
extern color  TDIposColor = clrLimeGreen; // RSI Price line
extern string TDIposLabel = "Green";      // PL Label (Green - Default)
extern color  TDInegColor = clrRed;       // Trade Signal Line
extern string TDInegLabel = "Red";        // TS Label (Red - Default)
extern color  Arrow_Bull = clrLimeGreen;  // Bull Trend
extern color  Neutral_Arrow = clrGray;    // Neutral Trend      
extern color  Arrow_Bear = clrRed;        // Bear Trend
extern color  Over_bought = clrLimeGreen; // Over Bought
extern color  Over_sold = clrRed;         // Over Sold
extern color  Wayover_bought = clrGreen;  // Wayover Bought
extern color  Wayover_sold = clrMaroon;   // Wayover Sold
extern color  Above_fifty = clrPaleGreen; // Above 50
extern color  Below_fifty = clrIndianRed; // Below 50
extern color  TDIgoodColor=clrGoldenrod;  // TDI Good Separation  
extern color  TDIstrongColor=clrGold;     // TDI Strong Separation
extern color  TDIdangerColor=clrDeepPink; // TDI Danger Zone
extern color  PositiveAngleColor=clrSilver;  // If Green Angle > Red Angle


// Global declarations
string TDI_Indicator;
int TDI_Indicator_RSIPrice;
int TDI_Indicator_TradeSig;

string sAngle;
string AngleLvl;
double GreenAngle_HX;
double RedAngle_HX;
string iGreenAngle;
double iGreenLevel;
string iTdiGreenLevel;
string iRedAngle;
double iRedLevel;
double test_TdiDistance;
double iTest_TdiDistance;
double convert2pips;
string ratio_display;
string iDegreeLabel;
string iDegreeValue;
string TdiDistance;
string iTdiDistance;
string symbol;
string Tdi_cross_HX;
string iTdi_Cross_HX;
string Tdi_zone_HX;
string iTdi_Zone_HX;
string sTDISpread;
color  slope_color_HX;
color  iSlope_Color_HX;
color  zone_color_HX;
color  iZone_Color_HX;
color  spread_color_HX = clrDimGray;


int iXPadding=4;
int iYPanelRatio =0+shiftDown;
int iXPaneRatio=7+iXOffset;
int iYPosHeader1 =18+shiftDown;
int iYPosHeader2 =32+shiftDown;
int iYPosHeader3 =48+shiftDown;
int iYPosSlopeInd =65+shiftDown;
int iYPosSpreadInd =89+shiftDown;
int iYPosZoneInd = 96+shiftDown;
int iYPosAngle = 115+shiftDown;

int xSepVal=8+iXOffset;
int xSepLbl=28+iXOffset;
int xRedAngl=14+iXOffset;
int xRedAngLbl=32+iXOffset;
int xGreenAngl=66+iXOffset;
int xGreenLbl=83+iXOffset;
int xInsSymbol=177+iXOffset;
int xTF=155+iXOffset;
int xAnglLvl=120+iXOffset;
int xAnglRat=125+iXOffset;
int xArrowLvl=181+iXOffset;
int xZoneLvl=166+iXOffset;

int iYPanel=10+shiftDown;
int iXPanel=0+iXOffset;
int iYDivider=52+shiftDown;
int iXDivider=0;
int Panel_Location = 1;
int xyz=0;

//---
// Start
//---
int start()
{

if (!showAngulardiff){
   iYPosHeader1 =18+shiftDown+5;
   iYPosHeader2 =32+shiftDown+5;
   iYPosHeader3 =48+shiftDown+5;
   iYPosSlopeInd =65+shiftDown+5;
   iYPosSpreadInd =89+shiftDown+5;
   iYPosZoneInd = 96+shiftDown+5;
   iYPosAngle = 115+shiftDown+5;
}
  

// Background Box and Get Panel Ratio
getPanelRatio();   
CreateBackground();

//--------------------------|
   
   //Load Default Symbol
   if (loadDefaultSymbol == "current" || loadDefaultSymbol == "")
         symbol  = Symbol(); 
   else  symbol = loadDefaultSymbol;
   if (StringSubstr(symbol,0,2)=="_t") symbol = StringSubstr(symbol,2);
   
   //Selected TDI indictor
   switch(inputTDI)
   {
      case  1: TDI_Indicator = "Traders_Dynamic_Index";  TDI_Indicator_RSIPrice =4; TDI_Indicator_TradeSig=5;  break;
      case  2: TDI_Indicator = "TMS-TDI-RT-Replica";     TDI_Indicator_RSIPrice =4; TDI_Indicator_TradeSig=3;  break; 
      case  3: TDI_Indicator = "TDI-Red-Green";          TDI_Indicator_RSIPrice =4; TDI_Indicator_TradeSig=5;  break;
      case  4: TDI_Indicator = "TDI-RT-Clone";           TDI_Indicator_RSIPrice =4; TDI_Indicator_TradeSig=3;  break;       
      case  5: TDI_Indicator = "TDI_RSI_10";            TDI_Indicator_RSIPrice =4; TDI_Indicator_TradeSig=5;  break;
      default: break;
   }
   
    //Load Default TF
   string   strTime = " ";
   switch(Period())
   {
      case  1:    strTime = "M1";
            SetTDIperiod(PERIOD_M1);
            SetHeaders(strTime);
            break;       
      case  5: strTime = "M5";
            SetTDIperiod(PERIOD_M5);
            SetHeaders(strTime);
            break;
      case  15:   strTime = "M15";
            SetTDIperiod(PERIOD_M15);
            SetHeaders(strTime);
            break;      
      case  30:   strTime = "M30";
            SetTDIperiod(PERIOD_M30);
            SetHeaders(strTime);
            break;      
      case  60:   strTime = "H1";
            SetTDIperiod(PERIOD_H1);
            SetHeaders(strTime);
            break;      
      case  240:  strTime = "H4";
            SetTDIperiod(PERIOD_H4);
            SetHeaders(strTime);
            break;       
      case  1440: strTime = "D1";
            SetTDIperiod(PERIOD_D1);
            SetHeaders(strTime);            
            break;       
      case 10080: strTime = "W1";
            SetTDIperiod(PERIOD_W1);
            SetHeaders(strTime);
            break;       
      case 43200: strTime = "MN1";  break;
            SetTDIperiod(PERIOD_MN1);
            SetHeaders(strTime);
            break;       
      default:    strTime = "";
   }
   
   //Load MTF Values
   
   switch(TFs)
   {
      case  1: xyz=25; // M1 M5 M15 M30 H1
            SetTFlabel("M1",145+xyz);
            SetTFlabel("M5",116+xyz);
            SetTFlabel("M15",87+xyz);
            SetTFlabel("M30",57+xyz);   
            SetTFlabel("H1",27+xyz);      
            SetTdiArrowAndZone(PERIOD_M1);            
            SetTdiValues("M1",142+xyz); 
            //Set Divider -----------------
            if(showTFdivider){SetVerticalDivider("vertical",131+xyz);} 
            //----------------------------              
            SetTdiArrowAndZone(PERIOD_M5);
            SetTdiValues("M5",113+xyz);   
            SetTdiArrowAndZone(PERIOD_M15);
            SetTdiValues("M15",84+xyz);
            SetTdiArrowAndZone(PERIOD_M30);
            SetTdiValues("M30",54+xyz);
            SetTdiArrowAndZone(PERIOD_H1);
            SetTdiValues("H1",24+xyz);
            break;  
      case  2: xyz=25; // M5 M15 M30 H1 H4
            SetTFlabel("M5",145+xyz);
            //Set Divider -----------------
            if(showTFdivider){SetVerticalDivider("vertical",133+xyz);} 
            //----------------------------              
            SetTFlabel("M15",116+xyz);
            SetTFlabel("M30",86+xyz);
            SetTFlabel("H1",56+xyz);   
            SetTFlabel("H4",27+xyz);      
            SetTdiArrowAndZone(PERIOD_M5);
            SetTdiValues("M5",142+xyz);  
            SetTdiArrowAndZone(PERIOD_M15);
            SetTdiValues("M15",113+xyz);   
            SetTdiArrowAndZone(PERIOD_M30);
            SetTdiValues("M30",83+xyz);
            SetTdiArrowAndZone(PERIOD_H1);
            SetTdiValues("H1",53+xyz);
            SetTdiArrowAndZone(PERIOD_H4);
            SetTdiValues("H4",24+xyz);
            break;    
      case  3: xyz=27;  // M15 M30 H1 H4 D1
            SetTFlabel("M15",145+xyz); 
            //Set Divider -----------------
            if(showTFdivider){SetVerticalDivider("vertical",131+xyz);} 
            //----------------------------                                     
            SetTFlabel("M30",115+xyz);
            SetTFlabel("H1",85+xyz);
            SetTFlabel("H4",56+xyz);   
            SetTFlabel("D1",27+xyz);      
            SetTdiArrowAndZone(PERIOD_M15);
            SetTdiValues("M15",142+xyz);  
            SetTdiArrowAndZone(PERIOD_M30);
            SetTdiValues("M30",112+xyz);   
            SetTdiArrowAndZone(PERIOD_H1);
            SetTdiValues("H1",82+xyz);
            SetTdiArrowAndZone(PERIOD_H4);
            SetTdiValues("H4",53+xyz);
            SetTdiArrowAndZone(PERIOD_D1);
            SetTdiValues("D1",24+xyz);
            break;
      case  4: xyz=39; // M15 M30 H1 H4
            SetTFlabel("M15",116+xyz);
            SetTFlabel("M30",86+xyz);
            SetTFlabel("H1",56+xyz);   
            SetTFlabel("H4",27+xyz);       
            SetTdiArrowAndZone(PERIOD_M15);
            SetTdiValues("M15",113+xyz);   
            SetTdiArrowAndZone(PERIOD_M30);
            SetTdiValues("M30",83+xyz);
            SetTdiArrowAndZone(PERIOD_H1);
            SetTdiValues("H1",53+xyz);
            SetTdiArrowAndZone(PERIOD_H4);
            SetTdiValues("H4",24+xyz);
            break;
      case  5: xyz=24; // M30 H1 H4 D1 W1
            SetTFlabel("M30",145+xyz);
            //Set Divider -----------------
            if(showTFdivider){SetVerticalDivider("vertical",131+xyz);} 
            //----------------------------             
            SetTFlabel("H1",115+xyz);
            SetTFlabel("H4",85+xyz);
            SetTFlabel("D1",56+xyz);   
            SetTFlabel("W1",27+xyz);
            SetTdiArrowAndZone(PERIOD_M30);
            SetTdiValues("M30",142+xyz);                     
            SetTdiArrowAndZone(PERIOD_H1);
            SetTdiValues("H1",112+xyz);   
            SetTdiArrowAndZone(PERIOD_H4);
            SetTdiValues("H4",82+xyz);
            SetTdiArrowAndZone(PERIOD_D1);
            SetTdiValues("D1",53+xyz);
            SetTdiArrowAndZone(PERIOD_W1);
            SetTdiValues("W1",24+xyz);
            break;  
      case  6: xyz=25;  //H1 H4 D1 W1 MN1
            SetTFlabel("H1",144+xyz);
            //Set Divider -----------------
            if(showTFdivider){SetVerticalDivider("vertical",131+xyz);} 
            //----------------------------            
            SetTFlabel("H4",115+xyz);
            SetTFlabel("D1",87+xyz);
            SetTFlabel("W1",56+xyz);   
            SetTFlabel("MN1",27+xyz);      
            SetTdiArrowAndZone(PERIOD_H1);
            SetTdiValues("H1",141+xyz);  
            SetTdiArrowAndZone(PERIOD_H4);
            SetTdiValues("H4",112+xyz);   
            SetTdiArrowAndZone(PERIOD_D1);
            SetTdiValues("D1",82+xyz);
            SetTdiArrowAndZone(PERIOD_W1);
            SetTdiValues("W1",53+xyz);
            SetTdiArrowAndZone(PERIOD_MN1);
            SetTdiValues("MN1",24+xyz);
            break;
      case  7: xyz=9;  // M5 M15 M30 H1 H4 D1
            SetTFlabel("M5",174+xyz);
            //Set Divider -----------------
            if(showTFdivider){SetVerticalDivider("vertical",163+xyz);} 
            //----------------------------    
            SetTFlabel("M15",145+xyz);
            SetTFlabel("M30",115+xyz);
            SetTFlabel("H1",85+xyz);
            SetTFlabel("H4",56+xyz);   
            SetTFlabel("D1",27+xyz);           
            SetTdiArrowAndZone(PERIOD_M5);
            SetTdiValues("M5",171+xyz);                  
            SetTdiArrowAndZone(PERIOD_M15);
            SetTdiValues("M15",142+xyz);  
            SetTdiArrowAndZone(PERIOD_M30);
            SetTdiValues("M30",112+xyz);   
            SetTdiArrowAndZone(PERIOD_H1);
            SetTdiValues("H1",82+xyz);
            SetTdiArrowAndZone(PERIOD_H4);
            SetTdiValues("H4",53+xyz);
            SetTdiArrowAndZone(PERIOD_D1);
            SetTdiValues("D1",24+xyz);
            break;             
      case  8: xyz=11;  // M15 M30 H1 H4 D1 W1
            SetTFlabel("M15",174+xyz);
            //Set Divider -----------------
            if(showTFdivider){SetVerticalDivider("vertical",160+xyz);} 
            //----------------------------                               
            SetTFlabel("M30",144+xyz);
            SetTFlabel("H1",114+xyz);
            SetTFlabel("H4",85+xyz);
            SetTFlabel("D1",56+xyz);   
            SetTFlabel("W1",27+xyz);           
            SetTdiArrowAndZone(PERIOD_M15);
            SetTdiValues("M15",171+xyz);                  
            SetTdiArrowAndZone(PERIOD_M30);
            SetTdiValues("M30",141+xyz);  
            SetTdiArrowAndZone(PERIOD_H1);
            SetTdiValues("H1",111+xyz);   
            SetTdiArrowAndZone(PERIOD_H4);
            SetTdiValues("H4",82+xyz);
            SetTdiArrowAndZone(PERIOD_D1);
            SetTdiValues("D1",53+xyz);
            SetTdiArrowAndZone(PERIOD_W1);
            SetTdiValues("W1",24+xyz);
            break;                                                                                                
      default:    
      break;
   }
   return(0);
} 
           
  
void SetHeaders(string sTime)  //Top Header Content
{
      //Instrument Symbol / TF
      int adjmnt=0;
      if(showSymbol){
         if (ObjectFind( Instance+"_iTFsymbol") == -1 ){ObjectCreate(Instance+"_iTFsymbol",OBJ_LABEL, Window,0,0);}
         ObjectSet(Instance+"_iTFsymbol",OBJPROP_CORNER,Panel_Location);
         ObjectSet(Instance+"_iTFsymbol",OBJPROP_XDISTANCE,xInsSymbol);
         ObjectSet(Instance+"_iTFsymbol",OBJPROP_YDISTANCE,iYPosHeader1);
         adjmnt =-8;
      } else adjmnt = 30;
     if(showCurrentTF  || (!showSymbol && showCurrentTF)){
         if (ObjectFind( Instance+"_iTF") == -1 ){ObjectCreate(Instance+"_iTF",OBJ_LABEL, Window,0,0);}
         ObjectSet(Instance+"_iTF",OBJPROP_CORNER,Panel_Location);
         ObjectSet(Instance+"_iTF",OBJPROP_XDISTANCE,xTF+adjmnt);
         ObjectSet(Instance+"_iTF",OBJPROP_YDISTANCE,iYPosHeader1);
       }
       if(showAngulardiff){
      //Angle Level
      ObjectCreate(Instance+"_AngleDiff",OBJ_LABEL, Window,0,0);
      ObjectSet(Instance+"_AngleDiff",OBJPROP_CORNER,Panel_Location);
      ObjectSet(Instance+"_AngleDiff",OBJPROP_XDISTANCE,xAnglLvl);
      ObjectSet(Instance+"_AngleDiff",OBJPROP_YDISTANCE,iYPosHeader1);
      ObjectSetText(Instance+"_AngleDiff",AngleLvl,Font_Size, Font_Type, Text_Color);
      }       
      //TDI Angle Ratio - WAVG
      ObjectCreate(Instance+"_iTdiAngleRatio",OBJ_LABEL, Window,0,0);
      ObjectSet(Instance+"_iTdiAngleRatio",OBJPROP_CORNER,Panel_Location);
      ObjectSet(Instance+"_iTdiAngleRatio",OBJPROP_XDISTANCE,xAnglRat);
      ObjectSet(Instance+"_iTdiAngleRatio",OBJPROP_YDISTANCE,iYPosHeader2);
      ObjectSetText(Instance+"_iTdiAngleRatio",iDegreeLabel+" "+iDegreeValue,Font_Size, Font_Type, Text_Color); 
      //Green Angle Colored Label
      ObjectCreate(Instance+"_iGreenLabel",OBJ_LABEL, Window,0,0);
      ObjectSet(Instance+"_iGreenLabel",OBJPROP_CORNER,Panel_Location);
      ObjectSet(Instance+"_iGreenLabel",OBJPROP_XDISTANCE,xGreenLbl);
      ObjectSet(Instance+"_iGreenLabel",OBJPROP_YDISTANCE,iYPosHeader2);
      ObjectSetText(Instance+"_iGreenLabel",TDIposLabel+": ",Font_Size, Font_Type, TDIposColor); 
      //Green Angle
      ObjectCreate(Instance+"_iGreenAngle",OBJ_LABEL, Window,0,0);
      ObjectSet(Instance+"_iGreenAngle",OBJPROP_CORNER,Panel_Location);
      ObjectSet(Instance+"_iGreenAngle",OBJPROP_XDISTANCE,xGreenAngl);
      ObjectSet(Instance+"_iGreenAngle",OBJPROP_YDISTANCE,iYPosHeader2);
      ObjectSetText(Instance+"_iGreenAngle",iGreenAngle,Font_Size, Font_Type, Text_Color);
      //Red Angle Colored Label
      ObjectCreate(Instance+"_iRedLabel",OBJ_LABEL, Window,0,0);
      ObjectSet(Instance+"_iRedLabel",OBJPROP_CORNER,Panel_Location);
      ObjectSet(Instance+"_iRedLabel",OBJPROP_XDISTANCE,xRedAngLbl);
      ObjectSet(Instance+"_iRedLabel",OBJPROP_YDISTANCE,iYPosHeader2);
      ObjectSetText(Instance+"_iRedLabel",TDInegLabel+": ",Font_Size, Font_Type, TDInegColor); 
      //Red Angle
      ObjectCreate(Instance+"_iRedAngle",OBJ_LABEL, Window,0,0);
      ObjectSet(Instance+"_iRedAngle",OBJPROP_CORNER,Panel_Location);
      ObjectSet(Instance+"_iRedAngle",OBJPROP_XDISTANCE,xRedAngl);
      ObjectSet(Instance+"_iRedAngle",OBJPROP_YDISTANCE,iYPosHeader2);
      ObjectSetText(Instance+"_iRedAngle",iRedAngle,Font_Size, Font_Type, Text_Color);       
      //Separation Label
      ObjectCreate(Instance+"_iTdiSeparationLabel",OBJ_LABEL, Window,0,0);
      ObjectSet(Instance+"_iTdiSeparationLabel",OBJPROP_CORNER,Panel_Location);
      ObjectSet(Instance+"_iTdiSeparationLabel",OBJPROP_XDISTANCE,xSepLbl);
      ObjectSet(Instance+"_iTdiSeparationLabel",OBJPROP_YDISTANCE,iYPosHeader1);      
      //Separation Value
      ObjectCreate(Instance+"_iTdiSeparation",OBJ_LABEL, Window,0,0);
      ObjectSet(Instance+"_iTdiSeparation",OBJPROP_CORNER,Panel_Location);
      ObjectSet(Instance+"_iTdiSeparation",OBJPROP_XDISTANCE,xSepVal);
      ObjectSet(Instance+"_iTdiSeparation",OBJPROP_YDISTANCE,iYPosHeader1);
      color colic = Text_Color;
      if (iTdiDistance == "Crossed UP")
         colic = TDIposColor;
      else if (iTdiDistance == "Crossed DOWN")
         colic = TDInegColor;
      else if (iTdiDistance == "Approaching")
         colic = Text_Color;
      else if (iTdiDistance == "Good")
         colic = TDIgoodColor; 
      else if (iTdiDistance == "STRONG")
         colic = TDIstrongColor;                       
      else if (iTdiDistance == "DANGER")
         colic = TDIdangerColor; 
      else colic = Text_Color;
      //Symbol, TF and Separation values
      ObjectSetText(Instance+"_iTFsymbol",symbol,Font_Size,Font_Type,colic);
      ObjectSetText(Instance+"_iTF",sTime,Font_Size,Font_Type,colic);
      ObjectSetText(Instance+"_iTdiSeparationLabel",iTdiDistance+": ",Font_Size, Font_Type,colic);
      ObjectSetText(Instance+"_iTdiSeparation",DoubleToStr(iTest_TdiDistance,1),Font_Size, Font_Type,Text_Color);
}


void SetTFlabel(string sTime, int iXTFspacing)
{
   //TF Label
   ObjectCreate(Instance+"_"+sTime+"_TFlabel",OBJ_LABEL, Window,0,0);
   ObjectSet(Instance+"_"+sTime+"_TFlabel",OBJPROP_CORNER,Panel_Location);
   ObjectSet(Instance+"_"+sTime+"_TFlabel",OBJPROP_XDISTANCE,iXTFspacing+iXOffset);
   ObjectSet(Instance+"_"+sTime+"_TFlabel",OBJPROP_YDISTANCE,iYPosHeader3);
   ObjectSet(Instance+"_"+sTime+"_TFlabel",OBJPROP_ANCHOR,ANCHOR_UPPER);
   ObjectSetText(Instance+"_"+sTime+"_TFlabel",sTime,Font_Size,Font_Type,Text_Color);
}

void SetVerticalDivider(string sTime, int iXTFspacing)            
{

   ObjectCreate(Instance+"_"+sTime+"_Divider",OBJ_RECTANGLE_LABEL,Window,0,0);
   ObjectSet(Instance+"_"+sTime+"_Divider",OBJPROP_CORNER,Panel_Location);
   ObjectSet(Instance+"_"+sTime+"_Divider",OBJPROP_COLOR, verticalLineColor);
   ObjectSet(Instance+"_"+sTime+"_Divider",OBJPROP_BORDER_TYPE,0);
   ObjectSet(Instance+"_"+sTime+"_Divider",OBJPROP_XSIZE, 2);
   ObjectSet(Instance+"_"+sTime+"_Divider",OBJPROP_YSIZE,60);
   ObjectSet(Instance+"_"+sTime+"_Divider",OBJPROP_BACK,transBackground);
   ObjectSet(Instance+"_"+sTime+"_Divider",OBJPROP_XDISTANCE,iXTFspacing+iXOffset);
   ObjectSet(Instance+"_"+sTime+"_Divider",OBJPROP_YDISTANCE,iYDivider);
}  
 

void SetTdiValues(string sTime, int iXTFspacing)
{
   //Arrow
   ObjectCreate(Instance+"_"+sTime+"_TFArrow",OBJ_LABEL, Window,0,0);
   ObjectSet(Instance+"_"+sTime+"_TFArrow",OBJPROP_CORNER,Panel_Location);
   ObjectSet(Instance+"_"+sTime+"_TFArrow",OBJPROP_BACK,transBackground);
   ObjectSet(Instance+"_"+sTime+"_TFArrow",OBJPROP_XDISTANCE,iXTFspacing+iXOffset+iXPadding);
   ObjectSet(Instance+"_"+sTime+"_TFArrow",OBJPROP_YDISTANCE,iYPosSlopeInd);
   ObjectSet(Instance+"_"+sTime+"_TFArrow",OBJPROP_ANCHOR,ANCHOR_UPPER);
   ObjectSetText(Instance+"_"+sTime+"_TFArrow",Tdi_cross_HX,MTFarrowSize,"Wingdings", slope_color_HX);
   //Spread
   ObjectCreate(Instance+"_"+sTime+"_TFspread",OBJ_LABEL, Window,0,0);
   ObjectSet(Instance+"_"+sTime+"_TFspread",OBJPROP_CORNER,Panel_Location);
   ObjectSet(Instance+"_"+sTime+"_TFspread",OBJPROP_BACK,transBackground);
   ObjectSet(Instance+"_"+sTime+"_TFspread",OBJPROP_XDISTANCE,iXTFspacing+iXOffset+iXPadding);
   ObjectSet(Instance+"_"+sTime+"_TFspread",OBJPROP_YDISTANCE,iYPosSpreadInd);
   ObjectSet(Instance+"_"+sTime+"_TFspread",OBJPROP_ANCHOR,ANCHOR_CENTER);
   ObjectSetText(Instance+"_"+sTime+"_TFspread",sTDISpread,MTFarrowSize,"Wingdings",spread_color_HX);
   //Zone Levels
   ObjectCreate(Instance+"_"+sTime+"_TFlevels",OBJ_LABEL, Window,0,0);
   ObjectSet(Instance+"_"+sTime+"_TFlevels",OBJPROP_CORNER,Panel_Location);
   ObjectSet(Instance+"_"+sTime+"_TFlevels",OBJPROP_BACK,transBackground);
   ObjectSet(Instance+"_"+sTime+"_TFlevels",OBJPROP_XDISTANCE,iXTFspacing+iXOffset+iXPadding);
   ObjectSet(Instance+"_"+sTime+"_TFlevels",OBJPROP_YDISTANCE,iYPosZoneInd);
   ObjectSet(Instance+"_"+sTime+"_TFlevels",OBJPROP_ANCHOR,ANCHOR_UPPER);
   if(showRSIplBoxType) ObjectSetText(Instance+"_"+sTime+"_TFlevels",Tdi_zone_HX,MTFboxSize,"Wingdings", zone_color_HX); 
   else ObjectSetText(Instance+"_"+sTime+"_TFlevels",iTdiGreenLevel,MTFboxSize-2,Font_Type,zone_color_HX);  
   
   //Angle Level
   if(showAngulardiff){
   ObjectCreate(Instance+"_"+sTime+"_AngleDiff",OBJ_LABEL, Window,0,0);
   ObjectSet(Instance+"_"+sTime+"_AngleDiff",OBJPROP_CORNER,Panel_Location);
   ObjectSet(Instance+"_"+sTime+"_AngleDiff",OBJPROP_ANCHOR,ANCHOR_CENTER);   
   ObjectSet(Instance+"_"+sTime+"_AngleDiff",OBJPROP_XDISTANCE,iXTFspacing+3+iXOffset);
   ObjectSet(Instance+"_"+sTime+"_AngleDiff",OBJPROP_YDISTANCE,iYPosAngle);
   ObjectSetText(Instance+"_"+sTime+"_AngleDiff",sAngle,Font_Size, Font_Type, Text_Color);
   }     
}

//--
// Functions
//--



void SetTDIperiod(int iPeriod_HX)
{
   
   double iGreenLevel0=iCustom(symbol,iPeriod_HX, TDI_Indicator, 13, 0, 34, 2, 0, 7, 0, TDI_Indicator_RSIPrice, 0);
   double iGreenLevel1=iCustom(symbol,iPeriod_HX, TDI_Indicator, 13, 0, 34, 2, 0, 7, 0, TDI_Indicator_RSIPrice, 1);
   double iRedLevel0=iCustom(symbol,iPeriod_HX, TDI_Indicator, 13, 0, 34, 2, 0, 7, 0, TDI_Indicator_TradeSig, 0);
   double iRedLevel1=iCustom(symbol,iPeriod_HX, TDI_Indicator, 13, 0, 34, 2, 0, 7, 0, TDI_Indicator_TradeSig, 1);
   double iGreenLevelDegrees=(MathArctan(iGreenLevel0 - iGreenLevel1)*180)/3.1415;
   double iRedLevelDegrees=(MathArctan(iRedLevel0 - iRedLevel1)*180)/3.1415; 
   double iTdiWAvgAngle_HX=(iRedLevelDegrees+(iGreenLevelDegrees*13/34.0))/(1+(13/34.0));
   double iAngle_HX=0;   
   double iTdiDegree;
   
   /**
   * Length (angular) of a shortest way between two angles.
   * It will be in range [0, 180].
   */
   double iAngle= distance(iGreenLevelDegrees,iRedLevelDegrees);
   AngleLvl=DoubleToStr(NormalizeDouble(iAngle,2),0)+"";
   //----------------------------------------------------------------------|   
   
   if (angleType == 0)
   {
      iTdiDegree=(iRedLevelDegrees+(iGreenLevelDegrees*13/34.0))/(1+(13/34.0));
      iDegreeValue=DoubleToStr(NormalizeDouble(iTdiDegree,2),0)+"";
      iDegreeLabel="WAvg Angle: ";
   }      
   else
   {
      iTdiDegree=iGreenLevelDegrees/iRedLevelDegrees;
      iDegreeValue=DoubleToStr(NormalizeDouble(iTdiDegree,2),2)+"";;
      iDegreeLabel="Rel. Angle:";
   }
      
   iTdiGreenLevel= DoubleToStr(iGreenLevel0,0);

   switch (angleType)
   {
      case 0: iAngle_HX=NormalizeDouble(iTdiWAvgAngle_HX,0); break;
      case 1: iAngle_HX=NormalizeDouble(iGreenLevelDegrees,0); break;
      case 2: iAngle_HX=NormalizeDouble(iRedLevelDegrees,0); break;
   }
   
   
   if (iAngle_HX > 60.0)
   { iTdi_Cross_HX=CharToStr(233); iSlope_Color_HX=Arrow_Bull; }
   else if (iAngle_HX > 30.0)
   { iTdi_Cross_HX=CharToStr(236); iSlope_Color_HX=Arrow_Bull; }
   else if (iAngle_HX < -60.0)
   { iTdi_Cross_HX=CharToStr(234); iSlope_Color_HX=Arrow_Bear; }
   else if (iAngle_HX < -30.0)
   { iTdi_Cross_HX=CharToStr(238); iSlope_Color_HX=Arrow_Bear; }
   else
   { iTdi_Cross_HX=CharToStr(232); iSlope_Color_HX=Neutral_Arrow; }   
  
   iGreenAngle=DoubleToStr(NormalizeDouble(iGreenLevelDegrees,0),0)+"";
   iRedAngle=DoubleToStr(NormalizeDouble(iRedLevelDegrees,0),0)+"";

   iGreenLevel=NormalizeDouble(iGreenLevel0,0);
   iRedLevel=NormalizeDouble(iRedLevel0,0);
    
   iTest_TdiDistance=NormalizeDouble(MathAbs(iGreenLevel0 - iRedLevel0),2);
   
   if (iGreenLevel0 >= iRedLevel0 && iGreenLevel1 < iRedLevel1)
      iTdiDistance="Crossed UP";
   else if (iRedLevel0 >= iGreenLevel0 && iRedLevel1 < iGreenLevel1)
      iTdiDistance="Crossed DOWN";
   else if (iTest_TdiDistance < TDI_cross_threshold)
      iTdiDistance="Approaching";
   else if (iTest_TdiDistance > TDI_cross_threshold && iTest_TdiDistance < TDI_normal_threshold)
      iTdiDistance="Good";
   else if (iTest_TdiDistance > TDI_normal_threshold)
      iTdiDistance="STRONG";
   else if (iTest_TdiDistance > 10)
      iTdiDistance="DANGER";
      
   iTdi_Zone_HX=CharToStr(110);
   if (iGreenLevel0 > 74.0)
      iZone_Color_HX=Wayover_bought;
   else if (iGreenLevel0 > 68.0)
      iZone_Color_HX=Over_bought;
   else if (iGreenLevel0 > 50.0)
      iZone_Color_HX=Above_fifty;
   else if(iGreenLevel0 > 32.0)
      iZone_Color_HX=Below_fifty;
   else if(iGreenLevel0 > 26.0)
      iZone_Color_HX=Over_sold;
   else
      iZone_Color_HX=Wayover_sold; 
               
}

void SetTdiArrowAndZone(int period_HX)
{
   double TdiGreen0_HX=iCustom(symbol,period_HX, TDI_Indicator, 13, 0, 34, 2, 0, 7, 0, TDI_Indicator_RSIPrice, 0);
   double TdiGreen1_HX=iCustom(symbol,period_HX, TDI_Indicator, 13, 0, 34, 2, 0, 7, 0, TDI_Indicator_RSIPrice, 1);
   double TdiRed0_HX=iCustom(symbol,period_HX, TDI_Indicator, 13, 0, 34, 2, 0, 7, 0, TDI_Indicator_TradeSig, 0);
   double TdiRed1_HX=iCustom(symbol,period_HX, TDI_Indicator, 13, 0, 34, 2, 0, 7, 0, TDI_Indicator_TradeSig, 1);
   double TdiGreenDegrees_HX=(MathArctan(TdiGreen0_HX - TdiGreen1_HX)*180)/3.1415;
   double TdiRedDegrees_HX=(MathArctan(TdiRed0_HX - TdiRed1_HX)*180)/3.1415;
   double TdiWAvgAngle_HX=(TdiRedDegrees_HX+(TdiGreenDegrees_HX*13/34.0))/(1+(13/34.0));
   double Angle_HX=0;
   
   //----- Absolute Difference between two angles ------|
   double iAngle= TdiGreenDegrees_HX - TdiRedDegrees_HX;
   iAngle= MathMod((iAngle+90), (180-90));
   sAngle=DoubleToStr(NormalizeDouble(iAngle,2),0)+"";
   //---------------------------------------------------|
   
   
   
   switch (angleType)
   {
      case 0: Angle_HX=NormalizeDouble(TdiWAvgAngle_HX,0); break;
      case 1: Angle_HX=NormalizeDouble(TdiGreenDegrees_HX,0); break;
      case 2: Angle_HX=NormalizeDouble(TdiRedDegrees_HX,0); break;
   }
   
   
   if (Angle_HX > 60.0)
   { Tdi_cross_HX=CharToStr(233); slope_color_HX=Arrow_Bull; }
   else if (Angle_HX > 30.0)
   { Tdi_cross_HX=CharToStr(236); slope_color_HX=Arrow_Bull; }
   else if (Angle_HX < -60.0)
   { Tdi_cross_HX=CharToStr(234); slope_color_HX=Arrow_Bear; }
   else if (Angle_HX < -30.0)
   { Tdi_cross_HX=CharToStr(238); slope_color_HX=Arrow_Bear; }
   else
   { Tdi_cross_HX=CharToStr(232); slope_color_HX=Neutral_Arrow; }

   iTdiGreenLevel= DoubleToStr(TdiGreen0_HX,0);

   Tdi_zone_HX=CharToStr(110);
   if (TdiGreen0_HX > 74.0)
      zone_color_HX=Wayover_bought;
   else if (TdiGreen0_HX > 68.0)
      zone_color_HX=Over_bought;
   else if (TdiGreen0_HX > 50.0)
      zone_color_HX=Above_fifty;
   else if(TdiGreen0_HX > 32.0)
      zone_color_HX=Below_fifty;
   else if(TdiGreen0_HX > 26.0)
      zone_color_HX=Over_sold;
   else
      zone_color_HX=Wayover_sold;

   double nTDISpread=NormalizeDouble(MathAbs(TdiGreen0_HX - TdiRed0_HX),2);
   if (TdiGreen0_HX >= TdiRed0_HX && TdiGreen1_HX < TdiRed1_HX)
      sTDISpread=""; // Crossed-Up
   else if (TdiRed0_HX >= TdiGreen0_HX && TdiRed1_HX < TdiGreen1_HX)
      sTDISpread=""; // Crossed-Down
   else if (nTDISpread < TDI_cross_threshold)
      sTDISpread=CharToStr(159);
   else if (nTDISpread > TDI_cross_threshold && nTDISpread < TDI_normal_threshold)
      sTDISpread="l";
   else if (nTDISpread > TDI_normal_threshold)
      sTDISpread="";
   else if (nTDISpread > 10)
      sTDISpread="N";
}



int init()
{
    
   return(0);
}

//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void getPanelRatio()
  {
//---
   //Panel Ratio Value
   ObjectCreate(Instance+"_PanelRatio", OBJ_LABEL,Window, 0, 0);
   ObjectSet(Instance+"_PanelRatio", OBJPROP_CORNER, Panel_Location);
   ObjectSet(Instance+"_PanelRatio", OBJPROP_XDISTANCE, iXPaneRatio);
   ObjectSet(Instance+"_PanelRatio", OBJPROP_YDISTANCE, iYPanelRatio);

   if (Window > 0 && showPanelRatio){
      double height=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0);
      double width=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0);
      ratio_display=(string)NormalizeDouble(width/height,2);
      ObjectSetText(Instance+"_PanelRatio", "Panel Ratio ( "+ratio_display+" )", Font_Size, Font_Type, PanelRatioColor);   
   } else  ObjectDelete(Instance+"_PanelRatio");
  
  }

   
	
double distance(double alpha, double omega) {
   double phi = MathMod(MathAbs(omega - alpha), 180);       // This is either the distance or 360 - distance
   double distance = phi > 90 ? 180 - phi : phi;
   return distance;
}



void objectCreate(string name,int x,int y,string text="-",int size=42,
                  string font="Arial",color colour=CLR_NONE)
  {
   ObjectCreate(name,OBJ_LABEL,Window,0,0);
   ObjectSet(name,OBJPROP_CORNER,1);
   ObjectSet(name,OBJPROP_COLOR,colour);
   ObjectSet(name,OBJPROP_XDISTANCE,x);
   ObjectSet(name,OBJPROP_YDISTANCE,y);
   ObjectSetText(name,text,size,font,colour);
  }
  

//--
// Deinit everything
//---
int deinit()
{
   clearScreen(Instance, true, NULL);
   return(0);
}


void clearScreen(string pref, bool clearComments, string exception)
{   
   if (clearComments) Comment("");
   
   int i;
   string name = "";

   for (i = ObjectsTotal(); i >= 0; i--) 
   {
      name = ObjectName(i);
      if (StringFind(name, pref, 0) > -1) 
      {
         if (exception == "0" || StringFind(name, exception,0) == -1) ObjectDelete(name);
      } 
   }
}

void CreateBackground()
{
      if(ObjectFind(Instance+"_PanelBox") == -1){ObjectCreate(Instance+"_PanelBox",OBJ_LABEL, Window,0,0); }
      ObjectSetText(Instance+"_PanelBox", "gg", 85, "Webdings");      
      ObjectSet(Instance+"_PanelBox", OBJPROP_CORNER, 1);
      ObjectSet(Instance+"_PanelBox", OBJPROP_BACK, transBackground);
      ObjectSet(Instance+"_PanelBox", OBJPROP_XDISTANCE, iXPanel);
      ObjectSet(Instance+"_PanelBox", OBJPROP_YDISTANCE, iYPanel);    
      ObjectSet(Instance+"_PanelBox", OBJPROP_COLOR, Back_Ground_Color);  
      
} 
/*
double MathModCorrect(double a, double b)
{ int tmpres= (int)(a/b);
return(a-tmpres*b);
}*/